	TITLE	CUENTACO.ASM
	.ORG	0000H
	JMP	0200H
	.ORG	0003H	;interrupcin INT0 para descontar
	JMP	INT0	;va a descontar una unidad	
RESL:	.EQU	50H
RESH:	.EQU	51H
LVERDE:	.REG	P2.0
LROJA:	.REG	P2.1

	.ORG	0200H
	MOV	IE,#81H	;habilito interrupcin INT0
	MOV	TMOD,#15H	;contador T0 y temporizador T1 ambos de16 bits
	MOV	TCON,#01H	;interrupcin por flanco 
	CLR	LROJA	;apago luz roja y 
	SETB	LVERDE	;enciendo luz verde
	CALL	BCD4BIN	;conversin de selectores
	CLR	C	;cargo contadores con el valor correcto
	MOV	A,#0FFH	;65536-N 
	SUBB	A,RESL	
	MOV	TL0,A	
	MOV	A,#0FFH	
	SUBB	A,RESH
	MOV	TH0,A
	MOV	A,TL0
	ADD	A,#01
	MOV	TL0,A
	MOV	A,TH0
	ADDC	A,#00
	MOV	TH0,A	;ya estn cargados los contadores
	SETB	TR0	;autorizo contador
MENOR:	JNB	TF0,$	;igual a nmero seleccionado
	CLR	LVERDE	;apago luz verde
INTERMIT:	CPL	LROJA	;enciendo luz roja
	MOV	R0,#5	;intermitencia de 2 hz
SALTO1:	MOV	TH1,#>15536
	MOV	TL1,#<15536
	SETB	TR1	;activo TR1
	JNB	TF1,$
	CLR	TR1	;desactivo T1
	CLR	TF1	;TF1=0
	DJNZ	R0,SALTO1
	JMP	INTERMIT


;------------------------------------------------------------------------------------------
; SUBRUTINA DE CONVERSIN DE 4 DGITOS BCD A BINARIO
;------------------------------------------------------------------------------------------
BCD4BIN:	MOV	A,P0	;leo unidades y decenas
	ANL	A,#0FH	;enmascaro unidades
	MOV	RESL,A	;guardo resultado unidades
	MOV	A,P0
	SWAP	A	;coloco decenas en nibble bajo
	ANL	A,#0FH	;enmascaro decenas
	MOV	B,#10	
	MUL	AB	;multiplico decenas por 10
	ADD	A,RESL	;sumo unidades + decenas
	MOV	RESL,A
	MOV	A,P1	;leo centenas y miles
	ANL	A,#0FH	;enmascaro centenas
	MOV	RESH,A
	MOV	A,P1
	SWAP	A	;coloco miles en nibble bajo
	ANL	A,#0FH	;enmascaro miles
	MOV	B,#10
	MUL	AB	;y las multiplico por 10
	ADD	A,RESH	;sumo centenas + miles
	MOV	B,#100	;multiplico el resultado de centenas + miles por 
100 
	MUL	AB	;para obtener el valor correcto
	ADD	A,RESL	;el nm a sumar est en el A y en el B
	MOV	RESL,A
	MOV	A,B
	ADDC	A,#00
	MOV	RESH,A
	RET


;-------------------------------------------------------------------------
; SUBRUTINA DE ATENCIN A INT0 - DESCUENTA 
;-------------------------------------------------------------------------
INT0:	CLR	C	;descuenta 1
	MOV	A,TL0
	SUBB	A,#01
	MOV	TL0,A
	MOV	A,TH0
	SUBB	A,#00
	MOV	TH0,A
	JB	TF0,LLENO
	RETI		;deja las luces como estaban
LLENO:	CLR	LROJA	;apago luz roja
	SETB	LVERDE	;enciendo luz verde
	MOV	SP,#09H
	MOV	08H,#<MENOR	;modifica direccin de retorno de la pila
	MOV	09H,#>MENOR
	MOV	TCON,#11H	;borra flag de rebase del contador, autoriza T0
	RETI		;deja INT0 por flanco y desactivo T1
	.END
