            .TITLE      DESPLAZA.ASM
	.ORG	0000H	;vector reset
	JMP	0200H	;comienzo del programa
	.ORG	0003H	;vectorizacin de la rutina INT0
	JMP	INT0	;comienzo de la rutina de interrupcin

	.ORG	0200H
	MOV	TCON,#01	;se programa INT0 por flanco
	MOV	IE,#81H	;habilita la interrupcin INT0
	MOV	A,#00H
	SETB	C	;se pone el carry a 1
IZQUIER:	RLC	A	;rotacin de un bit a la izquierda
	MOV	P2,A	;se escribe el el puerto P2
	CALL	RETARDO	;retardo en sealizacin
	JNB	A.7,IZQUIER	;si no llegamos al tope izquierdo, seguimos
DERECHA:	RRC	A	;rotacin de un bit a la derecha
	MOV	P2,A	
	CALL	RETARDO
	JNB	A.0,DERECHA	;si no llegamos al tope derecho sigo
	JMP	IZQUIER	;pasamos a movernos a la izquierda

;-----------------------------------------
; SUBRUTINA DE RETARDO
;-----------------------------------------
RETARDO:	MOV	TMOD,#01H
	MOV	R0,#10	;retardamos 0,05 * 10 = 0,5 segundos
CUENTA:	MOV	TH0,#>15536
	MOV	TL0,#<15536
	MOV	TCON,#11H	;activa TR0 , borra TF0 , INT0 activa por flanco
	JNB	TF0,$
	DJNZ	R0,CUENTA
	MOV	TCON,#01H	;para el temporizador y borra el flag TF0
	RET

;----------------------------------------------------
; SUBRUTINA DE ATENCIN A INT0
;----------------------------------------------------
INT0:	MOV	A,P2	;guardo estado de la sealizacin
	PUSH	A
	PUSH	TL0
	PUSH	TH0

	PUSH	TCON
	MOV	A,R0
	PUSH	A
	MOV	R1,#10	;parpadeo 10 veces
SALTO:	MOV	P2,#0FFH	;todos los bits encendidos
	CALL	RETARDO	;retardo sealizacin
	MOV	P2,#00H	;todos los bits a cero
	CALL	RETARDO	;retardo la sealizacin
	DJNZ	R1,SALTO
	POP	A
	MOV	R0,A
	POP	TCON
	POP	TH0
	POP	TL0
	POP	A
	MOV	P2,A
	RETI
	.END
