	.TITLE	EMPAQUET.ASM
	.ORG	0000H
	JMP	0200H
	.ORG	0003H	;vectorizo interrupcin INT0
	JMP	INT0	;comienzo de rutina de interrupcin
PMARCHA:	.REG	P0.0
SEMPAQ:	.REG	P0.2
MCINTA:	.REG	P2.0
MEMPAQ:	.REG	P2.1

	.ORG	0200H
	MOV	P2,#00H
	MOV	IE,#81H	;habilito interrupcin INT0
	MOV	TMOD,#05H	;contador T0 16 bits, control por software
	MOV	TCON,#01H	;interrupcin por flanco
MARCHA:	JNB	PMARCHA,$
SALTO:	CALL 	BCD_BIN	;conversin de BCD de 2 dgitos a binario
	MOV	A,#0FFH	;cargamos con el valor edecuado el contador
	CLR	C
	SUBB	A,50H
	INC	A	
	MOV	TL0,A
	MOV	TH0,#0FFH
	SETB	TR0	;autorizo contador manteniendo flanco de INT
	SETB	MCINTA	;activo cinta
	JNB	TF0,$	;espero fin de cuenta
	CLR	TF0	;borro el indicador de sobrepasamiento
	CLR	TR0	;anulo el contador manteniendo la interrupcin
	CLR	MCINTA	;paro cinta
	SETB	MEMPAQ	;activo empaquetadora
	JNB	SEMPAQ,$	;espero seal fin empaquetar
	CLR	MEMPAQ	;paro empaquetadora
	JMP	SALTO

;-------------------------------------------------------------------
; SUBRUTINA DE ATENCIN A INT0 - PARO
;-------------------------------------------------------------------
INT0:	MOV	A,P2	;guardo estado de seales
	PUSH	A
	PUSH	TH0
	PUSH	TL0	;guardo estado de cuenta
	MOV	P2,#00H	;desactivo las salidas
	JNB	PMARCHA,$	;espero rearme
	POP	TL0
	POP 	TH0
	POP	A
	MOV	P2,A
	RETI


;--------------------------------------------------------------------------
; SUBRUTINA DE CONVERSIN DE BCD A BINARIO
;--------------------------------------------------------------------------
BCD_BIN:	MOV	50H,P1	;leo nmero seleccionado
	MOV	A,50H	;lo cargo en el acumulador
	SWAP	A	;coloco decenas en nibble bajo
	ANL	A,#0FH	;enmascaro nibble bajo
	MOV	B,#10	;multiplico el valor que corresponde
	MUL	AB	;a las decenas por 10
	MOV	51H,A	;guardo resultado de decenas
	MOV	A,50H	;cargo el nmero
	ANL	A,#0FH	;enmascaro las unidades
	ADD	A,51H	;sumo a las unidades las decenas
	MOV	50H,A	;guardo el nmero en binario
	RET

	.END
