	.TITLE	IMPRESOR.ASM
	.ORG	0000H
	JMP	0200H
	.ORG	0003H	;interrupcin para avisar que
	JMP	INT0	;est listo el conversor
	.ORG	0013H	;interrupcin para avisar
	JMP	INT1	;que est lista la impresora
HABCAD:	.REG	P1.0
HABIMP:	.REG	P1.1

	.ORG	0200H
	MOV	P1,#00	;inicializo salidas
	MOV	IE,#85H	;autorizo interrupciones INT0 e INT1
	MOV	TCON,#05H	;por flanco ambas
	MOV	R1,#50	;nmero de datos
	MOV	R0,#30H	;origen de tabla
LEEDATO:	SETB	HABCAD	;activo la seal para el conversor
	CALL	RETARDO	;retardo 100 microsegundos
	CLR	HABCAD	;desactivo la seal para el conversor
	MOV	R2,#0FFH
	CJNE	R2,#00,$	;espero seal de dato convertido por el  CAD
	MOV	A,P0	;leo dato
	MOV	@R0,A	;y lo llevo a la tabla
	INC	R0
	DJNZ	R1,LEEDATO
	SETB	HABIMP	;conecto la impresora
	MOV	R2,#0FFH
	CJNE	R2,#00,$	;espero seal de preparada
	MOV	R1,#50
	MOV	R0,#30H
SACADATO:	MOV	A,@R0	;leo dato de la tabla
	MOV	P2,A	;y lo saco hacia la impresora
	INC	R0
	DJNZ	R1,SACADATO
	CLR	HABIMP	;desconecto la impresora
	JMP	FIN


;----------------------------------------------------------------------------------------
; SUBRUTINA DE ATENCIN A INT0 - SEAL DEL CAD AL P
;----------------------------------------------------------------------------------------
INT0:	MOV 	R2,#00H
	RETI

;--------------------------------------------------------------------------------------------------------
; SUBRUTINA DE ATENCIN A INT1 - SEAL DE LISTA LA IMPRESORA
;--------------------------------------------------------------------------------------------------------
INT1:	MOV	R2,#00H
	RETI

;-----------------------------------------
; SUBRUTINA DE RETARDO
;-----------------------------------------
RETARDO:	MOV	TMOD,#01H	;retardo de 100 microsegundos
	MOV	TH0,#>65453	;65536-100+2+14+1 = 65453
	MOV	TL0,#<65453	
	MOV	TCON,#15H
TIEMPO:	JNB	TF0,TIEMPO
	CLR	TR0	;desactivo el temporizador T0
	CLR	TF0	;TF0=0
	RET

FIN:	NOP
	.END
