	.TITLE	PRIORIDA.ASM
	.ORG	0000H
	JMP	0200H
	.ORG	0003H	;vectorizacin de interrupcin INT0
	JMP	INT0	;comienzo de la rutina de INT0
	.ORG	0013H	;vectorizacin de interrupcin INT1
	JMP	INT1	;comienzo de rutina de INT1
	.ORG	0200H
	MOV	TCON,#05H	; INT0 e INT1 activas por flanco
	MOV	IP,#04H	; INT1 prioridad alta
	MOV	IE,#85H	; habilita INT0 e INT1
	MOV	A,#00H
	SETB	C
IZQUIER:	RLC	A
	MOV	P2,A
	CALL	RETARDO
	JNB	A.7,IZQUIER
DERECHA:	RRC	A
	MOV	P2,A
	CALL	RETARDO
	JNB	A.0,DERECHA
	JMP	IZQUIER


;-----------------------------------------
; SUBRUTINA DE RETARDO
;-----------------------------------------
RETARDO:	MOV	TMOD,#01H
	MOV	R0,#10	; retardamos 0,05 * 10 = 0,5 segundos
CUENTA:	MOV	TH0,#3CH
	MOV	TL0,#0B0H
	CLR	TF0
	SETB	TR0	; TR0=1
	JNB	TF0,$	; mira TF0
	CLR	TR0	; TR0=0	
	DJNZ	R0,CUENTA
	RET
;----------------------------------------------------
; SUBRUTINA DE ATENCIN A INT0
;----------------------------------------------------
INT0:	MOV	A,P2
	PUSH	A
	PUSH	TL0
	PUSH	TH0
	PUSH	TCON
	MOV	A,R0
	PUSH	A
	MOV	R1,#10
SALTO:	MOV	P2,#0FFH
	CALL	RETARDO
	MOV	P2,#00H
	CALL	RETARDO
	DJNZ	R1,SALTO
	POP	A
	MOV	R0,A	
	POP	TCON
	POP	TH0
	POP	TL0
	POP	A
	MOV	P2,A
	RETI
;----------------------------------------------------
; SUBRUTINA DE ATENCIN A INT1
;----------------------------------------------------
INT1:	MOV	A,P2	;guardo estado de la seal
	PUSH	A
	PUSH	TL0	;guardo estado del temporizador
	PUSH	TH0
	PUSH	TCON
	MOV	A,R0
	PUSH	A
	MOV	R2,#08	
BUCLE:	MOV	P2,#0FH	;4 bits bajos a uno
	CALL	RETARDO	;retardo de sealizacin
	MOV	P2,#0F0H	;4 bits altos a uno
	CALL	RETARDO	;retardo de sealizacin
	DJNZ	R2,BUCLE
	POP	A
	MOV	R0,A
	POP	TCON	;recupero el estado de la temporizacin
	POP	TH0
	POP	TL0	;recupero estado del retardo
	POP	A	;recupero el acumulador
	MOV	P2,A
	RETI
	.END
