            .TITLE RELOJ.ASM
            .ORG      0000H
            JMP       INICIO
            .ORG      000BH
            JMP       INT_T0
SEGUNDOS:   .REG      R5
MINUTOS:    .REG      R4
HORAS:      .REG      R3
PINICIO:    .REG      P3.2
MIN/HOR:    .REG      P3.3
ZUMBADOR:   .REG      P2.0

INICIO:     MOV       P2,#00
            MOV       R0,#4     ; valor real 40
            MOV       R1,#2     ; valor real 100
            MOV       TMOD,#02H ;T0 8 Bits con autorecarga, c software
            MOV       TH0,#252    ;temporiza 250 s
            MOV       TL0,#252    ; valores reales de TH0 y TL0 6
            MOV       IE,#82H   ;habilita T0
BUCLE:      CALL      VIS_HORA
            JNB       MIN/HOR,AJ_HORAS ;ajusta horas
            MOV       MINUTOS,P1
            JMP       VEVALOR
AJ_HORAS:   MOV       HORAS,P1
VEVALOR:    MOV       A,#59H
            CLR       C
            SUBB      A,MINUTOS  ;59-MINUTOS
            JC        ERROR
            MOV       A,#23H
            CLR       C
            SUBB      A,HORAS     ;23-HORAS
            JC        ERROR
            CLR       ZUMBADOR
            JMP       VE_PINICIO
ERROR:      SETB      ZUMBADOR
            JMP       BUCLE
VE_PINICIO: JNB       PINICIO,BUCLE
            SETB      TR0
SALTO:      CALL      VIS_HORA
            JMP       SALTO

;---------------------------------
; SUBRUTINA DE VISUALIZACION
;---------------------------------
VIS_HORA:   MOV       A,MINUTOS
            ANL       A,#0FH
            ORL       A,#10H
            MOV       P0,A
            MOV       A,MINUTOS
            SWAP      A
            ANL       A,#0FH
            ORL       A,#20H
            MOV       P0,A
            MOV       A,HORAS
            ANL       A,#0FH
            ORL       A,#40H
            MOV       P0,A
            MOV       A,HORAS
            SWAP      A
            ANL       A,#0FH
            ORL       A,#80H
            MOV       P0,A
            RET

;---------------------------------
; SUBRUTINA DE INTERRUPCION
;---------------------------------
INT_T0:     DJNZ        R0,FIN
            MOV         R0,#4       ; valor real 40
            DJNZ        R1,FIN       
            MOV         R1,#2       ; valor real 100
            MOV         A,#1        ;incrementa los segundos
            ADD         A,SEGUNDOS
            DA          A
            MOV         SEGUNDOS,A
            CJNE        SEGUNDOS,#60H,FIN
            MOV         SEGUNDOS,#00
            MOV         A,#1        ;incrementa los minutos
            ADD         A,MINUTOS
            DA          A
            MOV         MINUTOS,A
            CJNE        MINUTOS,#60H,FIN
            MOV         MINUTOS,#00
            MOV         A,#1        ;incrementa las horas
            ADD         A,HORAS
            DA          A
            MOV         HORAS,A
            CJNE        HORAS,#24H,FIN
            MOV         HORAS,#00        
FIN:        RETI
            .END
