	.TITLE	TALADRO.ASM
	.ORG	0000H	;vector reset
	JMP	0200H
	.ORG	0003H	;vectorizacin de interrupcin externa
	JMP	INT0	;comienzo de rutina de interrupcin

PBAJA:	.REG	P0.0	;pulsador de bajada
FCI:	.REG	P0.1	;final de carrera inferior
FCS:	.REG	P0.2	;final de carrera superior
PPARO:	.REG	P0.3	;pulsador de paro
PCONT:	.REG	P0.4	;pulsador para continuar el funcionamiento
BAJART:	.REG	P2.0	;orden de bajar el taladro
SUBIRT:	.REG	P2.1	,orden de subir el taladro

	.ORG	0200H
	MOV	IE,#81H	;habilita INT0
	MOV	TCON,#01H	;activa INT0 flanco
INICIO:	MOV	P2,#00H	;salidas a 0
	JNB	FCS,SUBIR	;si no est arriba, lo subo
	JNB	PBAJA,$	
	SETB	BAJART	;bajo taladro
MIRAFCI:	JB	PPARO,PARASUBE  ;controlo pulsador de paro
	JNB	FCI,MIRAFCI	;miro si llegu abajo
PARASUBE:	CLR	BAJART	;paro
	CALL	RETARDO	;para no estar activos los dos rels a la vez
SUBIR:	SETB	SUBIRT	;subo taladro
	JNB	FCS,$	;miro si llegu arriba
	JMP	INICIO	

;-----------------------------------------
; SUBRUTINA DE RETARDO
;-----------------------------------------
RETARDO:	MOV	TMOD,#01H
	MOV	R0,#10	;retardo de 0.5 segundos
CUENTA:	MOV	TH0,#3CH
	MOV	TL0,#0B0H
	MOV	TCON,#11H	;activo TR0 y borro TF0
	JNB	TF0,$
	DJNZ	R0,CUENTA
	MOV	TCON,#01H	;desactivo temporizador y borro TF0
	RET

;----------------------------------------------------
; SUBRUTINA DE ATENCIN A INT0
;----------------------------------------------------
INT0:	MOV	A,P2	;guardo estado del taladro
	PUSH	A
	MOV	P2,#00H
	JNB	PCONT,$	;espero que se accione el pulsador de continuar
	POP	A
	MOV	P2,A	;recupero estado del taladro
	RETI

	.END
