;7.12. Sobre un tambor giratorio, movido por un motor, existen diversos ori-
;ficios en los que se mezcla el polvo del medicamento con el aglomerante 
;lquido para, posterioremente, prensar la mezcla y dar forma a la pastilla.
;Si el tambor se encuentra situado en la posicin correcta, se activa la
;salida del medicamento (P2.0) durante 1 segundo. Controlado por un detector
;de posicionamiento (P0.2), el tambor se desplaza (P2.1) una posicin al 
;ponerse en marcha el motor. En la nueva posicin se libera aglomerante
;(P2.2) durante 2 segundos. Despus de sto, hay un periodo de espera de
;3 segundos. Seguidamente el mbolo baja (P2.3) hasta activarse un final de
;carrera (P0.0) prensando la mezcla durante 1 segundo. Seguidamente el 
;mbolo sube (P2.4) hasta el tope (P0.1) situacin en la que finaliza el
;ciclo.
;El sistema dispone de un interruptor de arranque (P0.3).

          .TITLE    TAMBOR.ASM
          .ORG      0000H      ;vector reset
          JMP       0200H
FCI:      .REG      P0.0       ;fin de carrera inferior del mbolo
FCS:      .REG      P0.1       ;fin de carrera superior del mbolo
DETPOS:   .REG      P0.2       ;detector de posicin correcta
MARCHA:   .REG      P0.3       ;pulsador de marcha
MEDIC:    .REG      P2.0       ;vlvula del medicamento
MTAMBOR:  .REG      P2.1       ;motor del tambor
AGLOM:    .REG      P2.2       ;vlvula del aglomerante
MEBAJA:   .REG      P2.3       ;motor de mbolo-baja
MESUBE:   .REG      P2.4       ;motor de mbolo-sube
          .EXTERN   RETARDO    ;rutina externa de retardar 0,5 s.
          .ORG      0200H
          MOV       P2,#00H    ;inicializa las salidas
INICIO:   JNB       MARCHA,$   ;espera a pulsar marcha
          JB        DETPOS,MED ;si est en posicin correcta, medicamento
          SETB      MTAMBOR    ;si no lo est activa tambor
          JNB       DETPOS,$   ;hasta que lo est
          CLR       MTAMBOR    ;para tambor
MED:      SETB      MEDIC      ;sale medicamento
          CALL      RETARDO    ;retarda 1 segundo
          CALL      RETARDO
          CLR       MEDIC      ;para medicamento
          SETB      MTAMBOR    ;activa el tambor
          JNB       DETPOS,$   ;hasta llegar a posicin correcta
          CLR       MTAMBOR    ;para tambor
          SETB      AGLOM      ;sale aglomerante
          MOV       R0,#04     ;durante 4 x 0,5 = 2 segundos
TEM2:     CALL      RETARDO
          DJNZ      R0,TEM2
          CLR       AGLOM      ;para aglomerante
          MOV       R0,#06     ;retarda 6 x 0,5 = 3 segundos
TEM3:     CALL      RETARDO    
          DJNZ      R0,TEM3
          SETB      MEBAJA     ;baja el mbolo
          JNB       FCI,$      ;hasta abajo
          CLR       MEBAJA     ;para mbolo
          CALL      RETARDO    ;retarda 1 segundo
          CALL      RETARDO
          SETB      MESUBE     ;sube mbolo
          JNB       FCS,$      ;hasta arriba
          CLR       MESUBE     ;y para
          JMP       INICIO     ;otro ciclo, esperando marcha
          .END

