	.TITLE	TREN.ASM
	.ORG	0000H
	JMP	0200H
	.ORG	0003H
	JMP	INT0	; llegada del tren por la izquierda
	.ORG	0013H
	JMP	INT1	; llegada del tren por la derecha

;SENIZQ1         INT0
;SENDER1       INT1

FCCB1:	.REG	P0.0	; entradas puerto 0
FCAB1:	.REG	P0.1
FCCB2:	.REG	P0.2
FCAB2:	.REG	P0.3
SENDER2:	.REG	P0.4
SENIZQ2:	.REG	P0.5
LROJAI:	.REG	P2.0	; salidas puerto 2
LROJAD:	.REG	P2.1
LVERDEI:	.REG	P2.2
LVERDED:	.REG	P2.3
LROJACO:	.REG	P2.4
CONVIA:	.REG	P2.5
MB1BAJAR:	.REG	P1.0	; salidas puerto 1
MB1SUBIR:	.REG	P1.1
MB2BAJAR:	.REG	P1.2
MB2SUBIR:	.REG	P1.3

	.ORG	0200H
	MOV	IE,#85H	; habilitamos interrupciones externas INT0 e INT1
	MOV	TCON,#00H	;activas por nivel 
	MOV	P2,#00	;inicializo salidas
	MOV	P1,#00
SUBIRBA:	MOV	A,P0	; iinicialmente pueden estar abiertas o cerradas
	ANL	A,#00001010B	;informacin de los FCA de B1 y B2
	CLR	C
	SUBB	A,#10
	JZ	ABIERTAS	; salta si las dos barreras estn abiertas
	MOV	A,P0
	XRL	A,#11111111B
	ANL	A,#00001010B
	MOV	P1,A	; activa el motor de subir de la barrera no abierta
	JMP	SUBIRBA	; y para el motor de la barrera ya abierta
ABIERTAS:	MOV	P1,#00
	MOV	P2,#0CH	;activo luces verdes trenes, coches apagadas 
	JMP	$

; ---------------------------------------------
;   Llegada de tren por la izquierda
;----------------------------------------------
INT0:	CLR	LVERDED	;apago luz verde derecha de los trenes
	SETB	LROJAD	;enciendo luz roja derecha de los trenes
	SETB	CONVIA	;coloco conmutador de va en sentido a derechas
	CALL	INTERMIT
	SETB	LROJACO	;enciendo luz roja de coches
	MOV	P1,#00000101B	; bajo las dos barreras
MIRA$:	MOV	A,P0	;informacin de los FCC de B! y B2
	ANL	A,#00000101B
	CLR	C
	SUBB	A,#5
	JZ	CERRADAS$
	MOV	A,P0
	XRL	A,#11111111B
	ANL	A,#00000101B
	MOV	P1,A	; activa el motor de bajar la barrera no cerrada
	JMP	MIRA$	; y para el motor de la barrera ya cerrada
CERRADAS$:	MOV	P1,#00
	JNB	SENIZQ2,$	; espero llegada del tren a la derecha
	CLR	IE0	; borro flag IE0
	MOV	08H,#<SUBIRBA	; modifico la direccin de retorno en la pila
	MOV	09H,#>SUBIRBA
	RETI
; ---------------------------------------------
;   Llegada de tren por la derecha
;----------------------------------------------
INT1:	CLR	LVERDEI	;apago luz verde izquierda de los trenes
	SETB	LROJAI	;enciendo luz roja izquierda de los trenes
	CLR	CONVIA	;coloco conmutador de va en sentido a izquierda
	CALL	INTERMIT
	SETB	LROJACO	;enciendo luz roja de coches
	MOV	P1,#00000101B	; bajo las dos barreras
MIRA$:	MOV	A,P0	;informacin de los FCC de B! y B2
	ANL	A,#00000101B
	CLR	C
	SUBB	A,#5
	JZ	CERRADAS$
	MOV	A,P0
	XRL	A,#11111111B
	ANL	A,#00000101B
	MOV	P1,A	; activa el motor de bajar la barrera no cerrada
	JMP	MIRA$	; y para el motor de la barrera ya cerrada
CERRADAS$:	MOV	P1,#00
	JNB	SENDER2,$	;espero llegada del tren a la izquierda
	CLR	IE1	; borro flag IE1
	MOV	08H,#<SUBIRBA	; modifico la direccin de retorno en la pila
	MOV	09H,#>SUBIRBA
	RETI
;----------------------------------------------------------------------------------------------------
; SUBRUTINA DE INTERMITENCIA DE LA LUZ ROJA DE LOS COCHES 
;----------------------------------------------------------------------------------------------------
INTERMIT:	MOV	TMOD,#01H	
	MOV	R0,#8
PARPADEO:	CPL	LROJACO
	MOV	R1,#10
TIEMPO:	MOV	TL0,#0B0H
	MOV	TH0,#3CH
	CLR	TF0	; borramos TF0
	SETB	TR0	; activamos TR0 
	JNB	TF0,$
	CLR	TR0	; borramos TR0 
	DJNZ	R1,TIEMPO
	DJNZ	R0,PARPADEO
	RET

	.END
